c           to test ksbwig: sampling of breight-wigner type function
c       implicit none
c       integer i
c       real*8 e  
c       do i=1, 50000
c          call ksbwig(770.d0, 150.d0, e)
c          write(*, *) sngl(e)
c       enddo
c       end
c       *************************************************************
c       *
c       * ksbwig: give a random variable followng the breight-wigner
c       *         type distribution
c       *
c       *    note: no cut on the both sides of the distribution is made.
c       *         The user should do it for physical applications
c       *
c       *************************************************************
c
c       ksbwig(e0, g, e)
c distribution funcition is
c      de/( (e-e0)**2 + (g/2)**2)
c
        subroutine ksbwig(e0, g, e)
        implicit none
        real*8 e0, g, e
        real*8  u, pi

        parameter (pi=3.141592653589793238)
        call rndc(u)
        e=g/2 * tan( (u-.5)*pi ) + e0
        end
